
//-------------- file start ----------------
// * caffeine engine - audio.h
// * copyright 2002-3 zealouselixir software
// * created march 16, 2002
// * audio system declaration 
// * this file contains functions and
//   objects related to the engine's
//   audio system, which loads and 
//   manages the playing of files
//   of types such as mp3 and wav.
//------------------------------------------

//------------- directives -----------------

#ifndef CAFFEINE_AUDIO_H
#define CAFFEINE_AUDIO_H

#include "default.h"
#include "constants.h"
#include "engine.h"
#include "vector.h"
#include "bass.h"

//---------- audio functions ---------------

class CAudioSystem
{
   public:
		static CAudioSystem *Get()
		{
			if(!Instance)
			Init();
			return Instance;
		}

		static void Init();
		void Update();
		void Kill();

		HSTREAM LoadMP3(char *FileName);
		void PlayMP3(HSTREAM Stream, bool Loop);
		void UnloadMP3(HSTREAM Stream);

		void StopAll();

		void SetGlobalVolume(int Percent);
		int GetGlobalVolume();
		void SetChannelVolume(DWORD Handle, int Percent);

	//void SetGlobal3DProperties(float Rolloff, float DopplerFactor);
	//void SetListenerLocation(CVector Position, CVector Velocity, CVector Front, CVector Top);
	//void SetChannel3DProperties(DWORD Handle, float InnerCone, float OuterCone, float Delta = 0.0f);
	//void SetChannelLocation(DWORD Handle, CVector Position, CVector Orientation, CVector Velocity);

	private:
		static CAudioSystem *Instance;
		BASS_3DVECTOR BASS_Vector(CVector Source);
};


//------------- directives -----------------

#endif

//-------------- file end ------------------