
#include "bam.h"

void CBAModel::Load(char *ModelFile)
{
	ifstream BAMFile(ModelFile, ios::nocreate);

	char TextureFile[MAX_LINE_LENGTH];
	BAMFile >> TextureFile;
	Texture.Load(TextureFile);

	BAMFile >> NumVerts;

	VertexList = new CVector[NumVerts];
	TexList = new CVector[NumVerts];

	for(int i = 0; i < NumVerts; i++)
	{
		BAMFile >> TexList[i].x;
		BAMFile >> TexList[i].y;
		BAMFile >> VertexList[i].x;
		BAMFile >> VertexList[i].y;
		BAMFile >> VertexList[i].z;
	}
}

void CBAModel::Draw()
{
	Location.x = 500.0f, 
	Location.y = 300.0f;
	Location.z = -400.0f;

	Rotation.y += 0.15f;

	Texture.Use();

	glPushMatrix();
		glTranslatef(Location.x, Location.y, Location.z);
		glRotatef(Rotation.x, 1,0,0);
		glRotatef(Rotation.y, 0,1,0);
		glRotatef(Rotation.z, 0,0,1);
		glBegin(GL_QUADS);
			for(int i = 0; i < NumVerts; i++)
			{
				glTexCoord2f(TexList[i].x, 
					         TexList[i].y);
				glVertex3f(VertexList[i].x, 
					       VertexList[i].y, 
						   VertexList[i].z);
			}
		glEnd();
	glPopMatrix();

}

void CBAModel::Unload()
{
	if(VertexList)
		delete [] VertexList;
	VertexList = 0;
	if(TexList)
		delete [] TexList;
	TexList = 0;
}
