
#include "default.h"
#include "constants.h"
#include "vector.h"
#include "cafmath.h"
#include "texture.h"

class CBAModel
{
	public: 
		void Load(char *ModelFile);
		void Draw();
		void Unload();

		CBAModel() {};

		CBAModel(char *ModelFile)
		{
			Load(ModelFile);
		};

		~CBAModel()
		{
			Unload();
		}

	private:
		int NumVerts;

		CVector *VertexList;
		CVector *TexList;

		CTexture Texture;
		CVector Rotation;
		CVector Location;
};

