
#include "camera.h"

CCamera::CCamera()
: orient(0, 0, 0), pos(0, 0, 0)
{
}

void CCamera::Position(float X, float Y, float Z)
{
   pos.x = X;
   pos.y = Y;
   pos.z = Z;
}

void CCamera::Position(CVector New)
{
	pos = New;
}

void CCamera::Rotate(float Pitch, float Yaw, float Roll)
{
    orient.x += Pitch;
	if(orient.x > 90.0f)
		orient.x = 90.0f;
	if(orient.x < -90.0f)
		orient.x = -90.0f;
    orient.y += Yaw;
	if(orient.y > 180.0f)
		orient.y = -180.0f;
	if(orient.y < -180.0f)
		orient.y = 180.0f;
    // roll not yet implemented
}

void CCamera::Orient(CVector New)
{
	orient = New;
}

void CCamera::Reset()
{
	pos = orient = CVector(0,0,0);
}

void CCamera::SetPos(const int Axis, float Value)
{
	switch(Axis)
	{
		case X_AXIS:
			pos.x = Value;
			break;
		case Y_AXIS:
			pos.y = Value;
			break;
		case Z_AXIS:
			pos.z = Value;
			break;
		default:break;
	};
}

float CCamera::GetPos(const int Axis)
{
	switch(Axis)
	{
		case X_AXIS:
			return pos.x;
			break;
		case Y_AXIS:
			return pos.y;
			break;
		case Z_AXIS:
			return pos.z;
			break;
		default:break;
	};

	return 0;   // this shouldn't ever happen.
}

void CCamera::SetRotation(const int Axis, float Value)
{
	switch(Axis)
	{
		case X_AXIS:
			orient.x = Value;
			break;
		case Y_AXIS:
			orient.y = Value;
			break;
		case Z_AXIS:
			orient.z = Value;
			break;
		default:break;
	};
}

float CCamera::GetRotation(const int Axis)
{
	switch(Axis)
	{
		case X_AXIS:
			return orient.x;
			break;
		case Y_AXIS:
			return orient.y;
			break;
		case Z_AXIS:
			return orient.z;
			break;
		default:break;
	};

	return 0;   // this shouldn't ever happen.
}

void CCamera::Update()
{	
	glRotatef(orient.x, 1, 0, 0);
	glRotatef(90.0f + orient.y, 0, 1, 0);
	glTranslatef(-pos.x, -pos.y, -pos.z);
}

