
//-------------- file start ----------------
// * caffeine engine - constants.h
// * copyright 2002-3 zealouselixir software
// * created march 18, 2002
// * CAFFEINE_ code file
// * this file contains a list of error,
//   success, general, and system codes
//   used when dealing with the caffeine
//   interface. all functions should
//   have a return type of ErrorCode
//   if possible.
//------------------------------------------

//------------- directives -----------------

#ifndef CAFFEINE_CONSTANTS_H
#define CAFFEINE_CONSTANTS_H

//---------------includes-------------------

#define MAX_LINE_LENGTH 256

#define ever ;;

typedef enum ErrorCode
{
	CAFFEINE_OK = 0,

	CAFFEINE_EXIT = 100,

	CAFFEINE_ERROR_GENERIC = 200,

	CAFFEINE_ERROR_TERMINAL = 300,

	CAFFEINE_ERROR_TRANSIENT = 400
};

typedef enum InputType        // obsolete
{
	CAFFEINE_INPUT_DI = 0,

	CAFFEINE_INPUT_WIN32 = 1,

	CAFFEINE_INPUT_DEFAULT = CAFFEINE_INPUT_WIN32,

	CAFFEINE_INPUT_NONE = 2
};

typedef enum MouseButtonCode
{
	MOUSE_LEFT = 0,
	MOUSE_MIDDLE = 1,
	MOUSE_RIGHT = 2,
	MOUSE_OTHER = 3
};

typedef enum AudioType
{
	CAFFEINE_AUDIO_3D = 0,

	CAFFEINE_AUDIO_2D = 1,

	CAFFEINE_AUDIO_NONE = 2
};

typedef enum RendererType
{
	CAFFEINE_RENDERER_OPENGL = 0,

	CAFFEINE_RENDERER_DEFAULT = CAFFEINE_RENDERER_OPENGL,

	CAFFEINE_RENDERER_DIRECT3D = 1,
};

/*typedef enum RenderMode
{
	CAFFEINE_MODE_TRIANGLES = 0,
	
	CAFFEINE_MODE_TRIANGLESTRIP = 1,

	CAFFEINE_MODE_TRIANGLEFAN = 2,

	CAFFEINE_MODE_QUADS = 3
};*/

typedef enum RenderMode
{
	CAFFEINE_PERSPECTIVE,
	CAFFEINE_ORTHO,
	CAFFEINE_OTHER,
};

typedef enum WindowMode
{
	CAFFEINE_WINDOWMODE_WINDOWED = 0,

	CAFFEINE_WINDOWMODE_FULLSCREEN = 1,

	CAFFEINE_WINDOWMODE_DEFAULT = CAFFEINE_WINDOWMODE_FULLSCREEN,

	CAFFEINE_WINDOWMODE_ASKUSER = 2
};

//------------- directives -----------------

#endif // __CAFFEINE_ENGINE_H

//------------- file end -------------------
