

#ifndef CAFFEINE_CUTSCENE_ONE
#define CAFFEINE_CUTSCENE_ONE

#include "default.h"
#include "texture.h"
#include "engine.h"
#include "font.h"
#include "input.h"
#include "timer.h"

class CCutScene1
{
    public:
        static CCutScene1* Get()
        {
            if(!Instance)
                Instance = new CCutScene1;
            return Instance;
        };

        bool Draw();
		void Load();
		void Unload();

    protected:
        CCutScene1() {};

        ~CCutScene1()
        {
            if(Instance)
                delete Instance;
            Instance = 0;
        };

    private:
        static CCutScene1 *Instance;
		CEngine *Engine;

		CFont *Font;

        CTexture *TextureList;
		int NumTextures;
		char **LogoText;
		float LogoHeight;
		float LogoWidth;
		float LogoTime;

		float FrameTime;

		float FlashTime;
		float Dummy;

		long IntroMusic;

		int CurrentTexture;

		float SceneLength;
		float RunningTime;
};

#endif



