
#include "cutscene2.h"

CCutScene2 *CCutScene2::Instance = 0;

void CCutScene2::Load()
{
	Engine = CEngine::Get();

	SceneLength = 1.25;

	glDisable(GL_TEXTURE_2D);
}

bool CCutScene2::Draw()
{
	Engine->SetRenderMode(CAFFEINE_ORTHO);

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();

	CTimer::Get()->Update();

	static float SceneStart = CTimer::Get()->GetRunningTime();

	RunningTime = CTimer::Get()->GetRunningTime()-SceneStart;
	FrameTime = CTimer::Get()->GetLastFrameTime();

	float x, y;

	FlashTime += FrameTime;

	x = FlashTime/SceneLength;
	y = 2*x - 1;
	y = y*y*y*y;
	y = 1-y;

	glColor3f(y, y, y);

	glBegin(GL_QUADS);
		glTexCoord2f(0, 1); glVertex2i(0,   0);
		glTexCoord2f(0, 0); glVertex2i(0,   480);
		glTexCoord2f(1, 0); glVertex2i(640, 480);
		glTexCoord2f(1, 1); glVertex2i(640, 0);
	glEnd();

	SwapBuffers(Engine->GetContext());

	if(RunningTime > SceneLength)
		return false;

	if(CInputSystem::Get()->KeyDown(VK_ESCAPE))
	{
		while(CInputSystem::Get()->KeyDown(VK_ESCAPE));
		return false;
	}

	return true;
}

void CCutScene2::Unload()
{
	glEnable(GL_TEXTURE_2D);
}


