
#ifndef CAFFEINE_NODE
#define CAFFEINE_NODE

#include "default.h"

class CNode
{
	public:
		CNode *Next;
		CNode *Previous;

	public:
		CNode()
			: Next(0), Previous(0)
		{
		}

		virtual ~CNode()
		{
			Detach();
		}

		void AttachTo(CNode *NewPrevious)
		{
			Detach();

			Previous = NewPrevious;
			Next = Previous->Next;
			if(Next)
				Next->Previous = this;
			if(Previous->Next)
				Previous->Next = this;
		}

		void Attach(CNode *NewNext)
		{
			NewNext->AttachTo(this);
		}

		void Detach()
		{
			if(Previous)
				Previous->Next = Next;
			if(Next)
				Next->Previous = Previous;
		}

		CNode *GetLast()
		{
			if(Next)
				return GetLast();

			return this;
		}
};
			

#endif