
#include "startup.h"

CAFFEINE_DESC BootData =
{
	"Project:Ominous (v1.0b)",
	640,480,32,
	CAFFEINE_RENDERER_OPENGL,
	CAFFEINE_WINDOWMODE_ASKUSER
};

bool CALLBACK BootupDlgProc(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	switch(Msg)
	{
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDOK:
					if(IsDlgButtonChecked(hWnd, IDC_FULLSCREEN))
						BootData.window_mode = CAFFEINE_WINDOWMODE_FULLSCREEN;
					else
						BootData.window_mode = CAFFEINE_WINDOWMODE_WINDOWED;

					if(IsDlgButtonChecked(hWnd, IDC_BITDEPTH_32))
						BootData.bpp = 32;
					else
						BootData.bpp = 16;

					if(IsDlgButtonChecked(hWnd, IDC_SIZE_800x600))
					{
						BootData.height = 600;
						BootData.width = 800;
					}
					else if(IsDlgButtonChecked(hWnd, IDC_SIZE_1024x768))
					{
						BootData.height = 768;
						BootData.width = 1024;
					}
					else
					{
						BootData.height = 480;
						BootData.width = 640;
					}

					EndDialog(hWnd, IDOK);
					return true;

				case IDCANCEL:
					EndDialog(hWnd, IDCANCEL);
					return true;
				
				default:
					break;
			}

			switch(HIWORD(wParam))
			{
				case BN_CLICKED:
					CheckDlgButton(hWnd, lParam, BST_CHECKED);
					break;
				default:
					break;
			}
			break;

		case WM_INITDIALOG:
		{
			CheckDlgButton(hWnd, IDC_FULLSCREEN, BST_CHECKED);
			CheckRadioButton(hWnd, IDC_SIZE_640x480, IDC_SIZE_1024x768, IDC_SIZE_800x600);
			CheckRadioButton(hWnd, IDC_BITDEPTH_16, IDC_BITDEPTH_32, IDC_BITDEPTH_32);
			break;
		}

		default:
			break;
	}

	return 0; //DefDlgProc(hWnd, Msg, wParam, lParam);
}