
#ifndef CAFFEINE_TERRAIN
#define CAFFEINE_TERRAIN

#include "default.h"
#include "texture.h"
#include "vector.h"
#include "camera.h"
#include "object.h"

class CTerrain : public CObject
{
	public:
		CTerrain() { };
		CTerrain(char *height_file, char *texture_file, char*);
		CTerrain(char *height_file, char *texture_file, char*, 
			     float Scale, float WaterHeight);
		~CTerrain();

		float GetHeight(float x, float z);
		CVector GetScaledSize();

		void Draw() {};
		void Draw(CCamera *camera);
		float GetWaterLine();

	public:
		int Width;
		int Depth;
		float Scale;
		CVector *Terrain;

	private:
		void OnAI() {};
		void OnCollision(CObject *O) {};

		char *HeightFileName;
		char *TextureFileName;

		CTexture Texture;
		CTexture DetailMap;
		CTexture Water;

		float WaterHeight;

		unsigned int *IndexArray;
		float *TerrainData;
		float *TexCoordArray;
};

#endif
