
#include "texture.h"

bool CTexture::Load(char* file_name)
{
	unsigned char *BitmapData;

	glGenTextures(1, &ID);

	BitmapData = LoadBitmap(file_name, Height, Width);

	if(!BitmapData)
		MessageBox(0, "No BMP data!", file_name, MB_OK);

	glBindTexture(GL_TEXTURE_2D, ID);

	glTexImage2D(GL_TEXTURE_2D, 0, 3, Width, Height, 0, GL_RGB, GL_UNSIGNED_BYTE, BitmapData);

	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

	if(BitmapData)
		delete [] BitmapData;

	if(ID)
		return true;
	else
		return false;
}

void CTexture::Use()
{
	glBindTexture(GL_TEXTURE_2D, ID);
}

CTexture::~CTexture()
{
	if(ID)
		glDeleteTextures(1, &ID);
}
